;;; ../../git/cho@gitea.bubbletea.dev/dotfiles/home/default/.config/doom/eisenhower-matrix.el -*- lexical-binding: t; -*-

(after! org-agenda
;;; begin eisenhower matrix
(add-to-list 'org-agenda-custom-commands
             '("1" "Eisenhower matrix"
               ((tags-todo
                 "+PRIORITY=\"A\"-habits+todo"
                 ((org-agenda-overriding-header "Urgent and important"))))
              nil))

(add-to-list 'org-agenda-custom-commands
             '("2" "Eisenhower matrix"
               ((tags-todo
                 "+PRIORITY=\"B\"-habits+todo"
                 ((org-agenda-overriding-header "Important but not urgent"))))
              nil))

(add-to-list 'org-agenda-custom-commands
             '("3" "Eisenhower matrix"
               ((tags-todo
                 "+PRIORITY=\"C\"-habits+todo"
                 ((org-agenda-overriding-header "Urgent but not important"))))
              nil))

(add-to-list 'org-agenda-custom-commands
             '("4" "Eisenhower matrix"
               ((tags-todo
                 "+PRIORITY=0-PRIORITY=\"A\"-PRIORITY=\"B\"-PRIORITY=\"C\"-habits+todo"
                 ;"+PRIORITY=0+PRIORITY=\"D\"-habits+todo"
                 ((org-agenda-overriding-header "Neither important nor urgent"))))
              nil))


;-----------------------------------------------------------

;(org-toggle-sticky-agenda) ;generate differens agendas buffers in separated windows
;(setq org-agenda-sticky t)  ;generate differens agendas buffers in separated windows

(defun +eisenhower-matrix/agenda-1 ()
  (interactive)
  (org-agenda nil "1"))

;(global-set-key (kbd "C-c C-x C-d") '+eisenhower-matrix/agenda-1)


(defun +eisenhower-matrix/agenda-2 ()
  (interactive)
  (org-agenda nil "2"))

;(global-set-key (kbd "C-c C-x C-l") '+eisenhower-matrix/agenda-2)

(defun +eisenhower-matrix/agenda-3 ()
  (interactive)
  (org-agenda nil "3"))

;(global-set-key (kbd "C-c C-x C-r") '+eisenhower-matrix/agenda-3)


(defun +eisenhower-matrix/agenda-4 ()
  (interactive)
  (org-agenda nil "4"))

;(global-set-key (kbd "C-c C-x C-p") '+eisenhower-matrix/agenda-4)


(defun split-4-ways ()
  (interactive)
  (delete-other-windows)
  (split-window-right)
  (split-window-below)
  (windmove-right)
  (split-window-below)
  (windmove-left))
;(global-set-key (kbd "C-c C-x C-u") 'split-4-ways)

(defun +eisenhower-matrix/redo-all-agenda-buffers ()
  (interactive)
  (dolist (buffer (buffer-list))
    (with-current-buffer buffer
      (when (derived-mode-p 'org-agenda-mode)
        (org-agenda-redo t)))))

(defun +eisenhower-matrix/make-agendas ()
 (interactive)
  (+eisenhower-matrix/redo-all-agenda-buffers)
  (+eisenhower-matrix/agenda-1)
  (hide-mode-line-mode)
  (+eisenhower-matrix/agenda-2)
  (hide-mode-line-mode)
  (+eisenhower-matrix/agenda-3)
  (hide-mode-line-mode)
  (+eisenhower-matrix/agenda-4)
  (hide-mode-line-mode)
  )
;(global-set-key (kbd "C-c C-x C-t") '+eisenhower-matrix/make-agendas)

(defun +eisenhower-matrix/make-eisenhower-matrix ()
 (interactive)
 (+eisenhower-matrix/make-agendas) ;it opens: *Org Agenda(1)*, *Org Agenda(2)*, *Org Agenda(3)*, *Org Agenda(4)*
 (split-4-ways)  ;make the 4 quadrant windows
 (switch-to-buffer  "*Org Agenda(1)*")  ;put the Agenda(1) in the left, up quadrant
 (windmove-right)
 (switch-to-buffer  "*Org Agenda(2)*")  ;put the Agenda(2) in the right, up quadrant
 (windmove-down)
 (switch-to-buffer  "*Org Agenda(4)*")  ;put the Agenda(3) in the left, down quadrant
 (windmove-left)
 (switch-to-buffer  "*Org Agenda(3)*")  ;put the Agenda(4) in the right, down quadrant
 )

;;; end eisenhower matrix
)
