;;; ../../git/cho@gitea.bubbletea.dev/dotfiles/home/default/.config/doom/org-capture-config.el -*- lexical-binding: t; -*-

(after! org

  ;; examples: file:~/.emacs.d/modules/lang/org/config.el
  ;;           file:~/.emacs.d/modules/lang/org/autoload/org-capture.el

  ;; set locations personal and centralized files

  (defvar +org-capture-refile-file "ag/refile.org")
  (defun +org-capture-refile-file ()
    (expand-file-name +org-capture-refile-file org-directory))
  (defvar +org-capture-todo-custom-file "ag/todo.org")
  (defun +org-capture-todo-custom-file ()
    (expand-file-name +org-capture-todo-custom-file org-directory))
  (defvar +org-capture-custom-projects-file "ag/projects.org")
  (defun +org-capture-custom-central-project-todo-file ()
    "TODO"
    (+org--capture-central-file
     +org-capture-custom-projects-file (projectile-project-name)))
  (defun +org-capture-custom-central-project-notes-file ()
    "TODO"
    (+org--capture-central-file
     +org-capture-custom-projects-file (projectile-project-name)))
  (defun +org-capture-custom-central-project-changelog-file ()
    "TODO"
    (+org--capture-central-file
     +org-capture-custom-projects-file (projectile-project-name)))

  ;(add-to-list 'org-capture-templates
  ;      '(("s" "Slipbox" entry  (file "braindump/org/inbox.org")
  ;       "* %?\n")
  ;        ("t" "Personal todo" entry
  ;         (file+headline +org-capture-todo-file "Inbox")
  ;         "* [ ] %?\n%i\n%a" :prepend t)
  ;      )

  (setq org-capture-templates
        '(("t" "Personal todo" entry
          (file+headline +org-capture-todo-custom-file "todo")
          "* TODO %?\n%i\n%a" :prepend t)
          ("T" "Personal todo (no link)" entry
          (file+headline +org-capture-todo-custom-file "todo")
          "* TODO %?\n" :prepend t)

          ;;; i never use this
          ;("n" "Personal notes" entry
          ;(file+headline +org-capture-notes-file "Inbox")
          ;"* %u %?\n%i\n%a" :prepend t)
          ("r" "Personal refile file" entry
          (file +org-capture-refile-file)
          "* %u %?\n%i\n%a" :prepend t)

          ;; using org-journal atm, i will likely never use this
          ;("j" "Journal" entry
          ;(file+olp+datetree +org-capture-journal-file)
          ;"* %U %?\n%i\n%a" :prepend t)

          ;; Will use {project-root}/{todo,notes,changelog}.org, unless a
          ;; {todo,notes,changelog}.org file is found in a parent directory.
          ;; Uses the basename from `+org-capture-todo-file',
          ;; `+org-capture-changelog-file' and `+org-capture-notes-file'.
          ("p" "Templates for projects")
          ("pt" "Project-local todo" entry  ; {project-root}/todo.org
           (file+headline +org-capture-project-todo-file "Inbox")
           "* TODO %?\n%i\n%a" :prepend t)
          ("pn" "Project-local notes" entry  ; {project-root}/notes.org
           (file+headline +org-capture-project-notes-file "Inbox")
           "* %U %?\n%i\n%a" :prepend t)
          ("pc" "Project-local changelog" entry  ; {project-root}/changelog.org
           (file+headline +org-capture-project-changelog-file "Unreleased")
           "* %U %?\n%i\n%a" :prepend t)

          ;; reference for function: [[file:~/.emacs.d/modules/lang/org/autoload/org-capture.el::defun +org--capture-central-file (file project]]
          ;; Will use {org-directory}/{+org-capture-projects-file} and store
          ;; these under {ProjectName}/{Tasks,Notes,Changelog} headings. They
          ;; support `:parents' to specify what headings to put them under, e.g.
          ;; :parents ("Projects")
          ("o" "Centralized templates for projects")
          ("ot" "Project todo" entry
           (function +org-capture-custom-central-project-todo-file)
           "* TODO %?\n %i\n %a"
           :heading "Tasks"
           :prepend nil)
          ("on" "Project notes" entry
           (function +org-capture-custom-central-project-notes-file)
           "* %U %?\n %i\n %a"
           :heading "Notes"
           :prepend t)
          ("oc" "Project changelog" entry
           (function +org-capture-custom-central-project-changelog-file)
           "* %U %?\n %i\n %a"
           :heading "Changelog"
           :prepend t)

          ;; org books / general logging
          ("b" "Book log / General log (org)" item (function org-books-visit-book-log)
           "- %U %?" :prepend t)

          ;; zettelkasten
          ("s" "Slipbox" entry  (file "roam/inbox.org")
           "* %U %?\n")
          ("S" "Slipbox link" entry  (file "roam/inbox.org")
           "* %U %?\n %i\n %a")))
)
